// test_msr145Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "test_msr145.h"
#include "test_msr145Dlg.h"
#include "windows.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTest_msr145Dlg dialog

CTest_msr145Dlg::CTest_msr145Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest_msr145Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest_msr145Dlg)
	m_DLLVersion = 0;
	m_OpenComport = 0;
	m_Port = _T("");
	m_GetValue = 0;
	m_CloseComport = 0;
	m_Value = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

/////////////////////////////////////////////////////////////////////////////
// MSR145
	funcGetDLLVersion= 0;
	funcOpenComport= 0;
	funcCloseComport= 0;
	funcWakeUp= 0;
	funcTxRx= 0;
	hinstLib = LoadLibrary("msr145_1.dll");

	if(hinstLib){    
        funcGetDLLVersion = (GetDLLVersion*) GetProcAddress(hinstLib, "GetDLLVersion");
		funcOpenComport = (OpenComport*) GetProcAddress(hinstLib, "OpenComport");
		funcCloseComport = (CloseComport*) GetProcAddress(hinstLib, "CloseComport");
		funcWakeUp = (WakeUp*) GetProcAddress(hinstLib, "WakeUp");
		funcTxRx = (TxRx*) GetProcAddress(hinstLib, "TxRx");
	} 
/////////////////////////////////////////////////////////////////////////////

}

void CTest_msr145Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest_msr145Dlg)
	DDX_Text(pDX, IDC_EDIT1, m_DLLVersion);
	DDX_Text(pDX, IDC_EDIT2, m_OpenComport);
	DDX_Text(pDX, IDC_EDIT3, m_Port);
	DDX_Text(pDX, IDC_EDIT5, m_GetValue);
	DDX_Text(pDX, IDC_EDIT4, m_CloseComport);
	DDX_Text(pDX, IDC_EDIT6, m_Value);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest_msr145Dlg, CDialog)
	//{{AFX_MSG_MAP(CTest_msr145Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest_msr145Dlg message handlers

BOOL CTest_msr145Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest_msr145Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTest_msr145Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CTest_msr145Dlg::DestroyWindow() 
{
/////////////////////////////////////////////////////////////////////////////
// MSR145
	if(hinstLib)
		FreeLibrary(hinstLib);
/////////////////////////////////////////////////////////////////////////////
	
	return CDialog::DestroyWindow();
}

/////////////////////////////////////////////////////////////////////////////
// MSR145

void CTest_msr145Dlg::OnButton1() 
{
	UpdateData(TRUE);
	if(funcGetDLLVersion)
		m_DLLVersion= (*funcGetDLLVersion) ();	
	UpdateData(FALSE);
}

void CTest_msr145Dlg::OnButton2() 
{
	UpdateData(TRUE);
	if(funcOpenComport)
	{
		m_OpenComport= (*funcOpenComport) (0, (LPSTR)(m_Port.GetBuffer(m_Port.GetLength())));
		m_Port.ReleaseBuffer();
	}
	UpdateData(FALSE);
}

void CTest_msr145Dlg::OnButton3() 
{
	UpdateData(TRUE);
	if(funcCloseComport)
		m_CloseComport= (*funcCloseComport) (0);	
	UpdateData(FALSE);
}

void CTest_msr145Dlg::OnButton4() 
{
	UCHAR out0, out1, out2, out3, out4, out5, out6;

	UpdateData(TRUE);
	if(funcWakeUp&&funcTxRx)
	{
		//--- WakeUp -----------------------------------------------------------------
		m_GetValue= (*funcWakeUp) (0);

		//--- Start measurements -----------------------------------------------------
		if(m_GetValue==0)
			m_GetValue= (*funcTxRx)(
			    0,
				6, 3, 0, 0xFF, 0xFF, 0, 0,
				&out0, &out1, &out2, &out3, &out4, &out5, &out6
			);


		Sleep(500);

		//--- Read results -----------------------------------------------------------
		if(m_GetValue==0)
			m_GetValue= (*funcTxRx)(
				0,
				2, 2,
				0, 1, 2,
				0, 0,
				&out0, &out1, &out2, &out3, &out4, &out5, &out6
			);

		if(m_GetValue==0)
			m_Value.Format("%.1f mbar", (float)((((WORD)out2) << 8) + (WORD)out1)/10);
	}

	UpdateData(FALSE);	
}

